#include <cstdio>
#include <iostream>

#include "matrix.h"
#include "ematrix.h"
#include "dmatrix.h"

//#define KECY

using namespace std;

CDeterminantMatrix::CDeterminantMatrix() :
  CEnhancedMatrix()
{
#ifdef KECY
  cout << "CDeterminantMatrix::CDeterminantMatrix();" << endl;
#endif
}

CDeterminantMatrix::CDeterminantMatrix(int _m, int _n) :
  CEnhancedMatrix(_m, _n)
{
#ifdef KECY
  cout << "CDeterminantMatrix::CDeterminantMatrix(" << _m << ", " << _n << ");" << endl;
#endif
}

CDeterminantMatrix::CDeterminantMatrix(const CMatrix& Matrix) :
  CEnhancedMatrix(Matrix)
{
#ifdef KECY
  cout << "CDeterminantMatrix::CDeterminantMatrix(Matrix);" << endl;
#endif
}

CDeterminantMatrix::CDeterminantMatrix(int _m, int _n, char *_matrix) :
  CEnhancedMatrix(_m, _n, _matrix)
{
#ifdef KECY
  cout << "CDeterminantMatrix::CDeterminantMatrix(" << _m << ", " << _n << ", \"_matrix\");" << endl;
#endif
}

CDeterminantMatrix::~CDeterminantMatrix()
{
#ifdef KECY
  cout << "CDeterminantMatrix::~CDeterminantMatrix();" << endl;
#endif
}

double CDeterminantMatrix::Determinant()
{
  int fact = 1, n, i, j;
  double determinant = 0.0, tmp;
  int *idx;

  /* only square matrices have a determinant */
  if (GetRows() != GetCols())
    throw CMatrixError(M_BAD_SIZE);

  n = GetRows();

  /* first compute factorial n! */
  for (i = 2; i <= n; i++)
    fact *= i;

  /* allocate index array */
  try {
    if ((idx = new int[n]) == NULL)
      throw CMatrixError(M_NO_MEM_AUX);
  } catch(bad_alloc) { throw CMatrixError(M_NO_MEM_AUX); }

  /* initialize index array */
  for (i = 0; i < n; i++)
    idx[i] = i;

  /* now compute determinant using permutations */
  for (i = 0; i < fact; i++)
  {
    tmp = 1.0;
    for (j = 0; j < n; j++)
      tmp *= GetField(j, idx[j]);
    determinant += (i % 2 ? -1: +1) * tmp;

    /* permute */
    j = idx[(i + 1) % n];
    idx[(i + 1) % n] = idx[i % n];
    idx[i % n] = j;
  }

  delete[] idx;

  return determinant;
}
