#include <math.h>
#include "meps.h"

#define EPSILON_FUNC(type, name)\
  static type name##_eps_func()\
  {\
    type e = 1.0;\
    type i = 0.0;\
    while (i != 1.0)\
    {\
      e /= 2.0;\
      i = 1.0 + (e/2.0);\
    }\
    return e;\
  }

static long double epsilon2(long double epsilon)
{
  return pow(10.0, (long int) log10(epsilon) + 5);
}
    
EPSILON_FUNC(float, f)
EPSILON_FUNC(double, lf)
EPSILON_FUNC(long double, Lf)

float f_eps;
double lf_eps;
long double Lf_eps;

float f_eps2;
double lf_eps2;
long double Lf_eps2;

__attribute__((constructor)) static void _meps_constructor()
{
  f_eps = f_eps_func();
  lf_eps = lf_eps_func();
  Lf_eps = Lf_eps_func();

  f_eps2 = epsilon2(f_eps);
  lf_eps2 = epsilon2(lf_eps);
  Lf_eps2 = epsilon2(Lf_eps);
}
