#include <cstdio>
#include <cstring>
#include <cstdarg>
#include <iostream>

#include "matrix.h"
#include "ematrix.h"
#include "gmatrix.h"
#include "printmatrix.h"

char *merrmessages[] = {
  NULL,
  "invalid matrix size",
  "out of bounds",
  "incompatible matrix size",
  "not enough memory",
  "not enough memory for auxiliary operation",
  "block matrix is not initialized",
  NULL };

using namespace std;

int main()
{ 
  cout << "BEGIN" << endl;
try {
  cout << "Creating matrices:" << endl;
  CMatrix M1(3, 3,
    "1;1;2;"
    "-1;0;0;"
    "0;1;2;");
  cout << "M1" << endl;
  CMatrix M2(3, 3,
    "0;0;0;"
    "0;0;0;"
    "0;-1;0;");
  cout << "M2" << endl;
  CMatrix M3(3, 3,
    "0;-1;0;"
    "-1;-1;1;"
    "0;3;1;");
  cout << "M3" << endl;
/*  CGaussMatrix M3(3, 3,
    "0;-1.0;0;"
    "-1.0;-1.0;1;"
    "0;3;1;");
  cout << "M3 ";
  CGaussMatrix M4(3, 3,
    "0;0;-1.0;"
    "0;0;0;"
    "0;0;-1.0;");
  cout << "M4 ";
  CGaussMatrix M5(3, 3,
    "1;1;2;"
    "-1.0;0;0;"
    "0;1;2;");
  cout << "M5 ";
  CGaussMatrix M6(3, 3,
    "1;0;-1.0;"
    "0;0;1;"
    "0;0;0;");
  cout << "M6 ";*/
  CMatrix Mtx1, Mtx2;
  cout << "Mtx1 Mtx2" << endl;

  Mtx1 = M1 * M2;
  cout << "Mtx1 = M1 * M2;" << endl;
} catch (CMatrixError &Err) {
  cout << "UNHANDLED MATRIX EXCEPTION:" << endl;
  cout << "The following error occured: " << merrmessages[Err.ID()] << endl;
}  catch (exception &Err) {
  cout << "UNHANDLED EXCEPTION:" << endl;
  cout << Err.what() << endl;
}
  cout << "THE END" << endl;
  return 0;
}
