#include <cstdio>
#include <cstring>
#include <cstdarg>
#include <iostream>
#include <ctime>

#include "matrix.h"
#include "ematrix.h"
#include "gmatrix.h"
#include "dmatrix.h"
#include "printmatrix.h"

using namespace std;

int main()
{ try {

  CDeterminantMatrix Matrix(3, 3,
    "1;3;5;"
    "4;3;1;"
    "2;2;1;");

  int N = 10;
  int i, j;
  clock_t clk;
  CDeterminantMatrix Mtx(N, N);

  srand(time(0));
  PrintMatrix(Matrix);
  printf("%f\n", Matrix.Determinant());

  for (i = 0; i < N; i++)
    for (j = 0; j < N; j++)
      Mtx.SetField(i, j, (double) rand() / (double) RAND_MAX);

  clk = clock();
  printf("%dx%d determinant: %f\n", N, N, Mtx.Determinant());
  clk = clock() - clk;
  printf("%.3f seconds\n", (float) clk / CLOCKS_PER_SEC);
      
  return 0;
  
} catch (CMatrixError &Err) {
  cout << "UNHANDLED MATRIX EXCEPTION:" << endl;
  cout << "The following error occured: " << Err.what() << endl;
} catch (exception &Err) {
  cout << "UNHANDLED EXCEPTION:" << endl;
  cout << Err.what() << endl;
} catch (...) {
  cout << "UNKNOWN EXCEPTION" << endl;
} }


